package com.logntw.eva.eclipselink;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;

import com.logntw.eva.eclipselink.entity.EntityTest;

public final class Main 
{
	private Main(){}
	public static void main(String... args) throws Exception
	{
		EntityManagerFactory factory = Persistence.createEntityManagerFactory("EclipseLink_Performance");
		EntityManager em = factory.createEntityManager();		
		
		long start, end;
		
		final int ENTITIES = 10000;	
		final int LOOP = 100;	
		final EntityTest[] ENTITY_ARR = new EntityTest[ENTITIES]; 
				
		
		
		
		start = System.currentTimeMillis();
		em.getTransaction().begin();
		for(int i = 0; i < ENTITIES ; i ++)
		{
			EntityTest entity = new EntityTest();
			entity.setId(i);
			entity.setName("ABC");
			entity.setAge(10);
			ENTITY_ARR[i] = entity;			
			em.persist(entity);				
		}				
		em.getTransaction().commit();
		end = System.currentTimeMillis();
		System.out.println("The insertion of "+ENTITIES+" entities spent "+ (end - start) + " milliseconds.");

		
		
		
		
		start = System.currentTimeMillis();
		Query q = em.createQuery("select t from EntityTest t");	    
		for(int i = 0; i < LOOP; i++)
		{						
			q.getResultList();			
		}		
		end = System.currentTimeMillis();
		System.out.println("The "+ LOOP + " times selection of the "+ENTITIES+" entities spent "+ (end - start) + " milliseconds.");
		
		
		
		
		
		
		start = System.currentTimeMillis();
		for(int i = 0; i < ENTITIES; i++)
		{
			EntityTest entity = ENTITY_ARR[i];			
			entity.setName("DEF");
			em.merge(entity);
		}				
		end = System.currentTimeMillis();
		System.out.println("The update of "+ENTITIES+" entities spent "+ (end - start) + " milliseconds.");
		
		
		
		
		
		start = System.currentTimeMillis();		
		for(int i = 0; i < ENTITIES; i++)
		{
			EntityTest entity = ENTITY_ARR[i];			
			em.remove(entity);
		}		
		end = System.currentTimeMillis();
		System.out.println("The deletion of "+ENTITIES+" entities spent "+ (end - start) + " milliseconds.");
		
		
		
		
		
		System.out.println("Press any key to exist.");
		System.in.read();
	}
}
